Index: pjproject/branches/1.x/pjsip/src/test/tsx_uas_test.c
===================================================================
--- pjproject/branches/1.x/pjsip/src/test/tsx_uas_test.c	(revision 3557)
+++ pjproject/branches/1.x/pjsip/src/test/tsx_uas_test.c	(revision 4385)
@@ -353,6 +353,6 @@
 static void tsx_user_on_tsx_state(pjsip_transaction *tsx, pjsip_event *e)
 {
-    if (pj_strcmp2(&tsx->branch, TEST1_BRANCH_ID)==0 ||
-	pj_strcmp2(&tsx->branch, TEST2_BRANCH_ID)==0) 
+    if (pj_stricmp2(&tsx->branch, TEST1_BRANCH_ID)==0 ||
+	pj_stricmp2(&tsx->branch, TEST2_BRANCH_ID)==0) 
     {
 	/*
@@ -363,5 +363,5 @@
 	 * TEST2_BRANCH_ID does similar test for non-2xx final response.
 	 */
-	int status_code = (pj_strcmp2(&tsx->branch, TEST1_BRANCH_ID)==0) ?
+	int status_code = (pj_stricmp2(&tsx->branch, TEST1_BRANCH_ID)==0) ?
 			  TEST1_STATUS_CODE : TEST2_STATUS_CODE;
 
@@ -393,5 +393,5 @@
     }
     else
-    if (pj_strcmp2(&tsx->branch, TEST3_BRANCH_ID)==0) {
+    if (pj_stricmp2(&tsx->branch, TEST3_BRANCH_ID)==0) {
 	/*
 	 * TEST3_BRANCH_ID tests sending provisional response.
@@ -456,5 +456,5 @@
 
     } else
-    if (pj_strcmp2(&tsx->branch, TEST4_BRANCH_ID)==0) {
+    if (pj_stricmp2(&tsx->branch, TEST4_BRANCH_ID)==0) {
 	/*
 	 * TEST4_BRANCH_ID tests receiving retransmissions in TRYING state.
@@ -489,5 +489,5 @@
 
     } else
-    if (pj_strcmp2(&tsx->branch, TEST5_BRANCH_ID)==0) {
+    if (pj_stricmp2(&tsx->branch, TEST5_BRANCH_ID)==0) {
 	/*
 	 * TEST5_BRANCH_ID tests receiving retransmissions in PROCEEDING state
@@ -526,5 +526,5 @@
 
     } else
-    if (pj_strcmp2(&tsx->branch, TEST6_BRANCH_ID)==0) {
+    if (pj_stricmp2(&tsx->branch, TEST6_BRANCH_ID)==0) {
 	/*
 	 * TEST6_BRANCH_ID tests receiving retransmissions in COMPLETED state
@@ -561,6 +561,6 @@
 
     } else
-    if (pj_strcmp2(&tsx->branch, TEST7_BRANCH_ID)==0 ||
-	pj_strcmp2(&tsx->branch, TEST8_BRANCH_ID)==0) 
+    if (pj_stricmp2(&tsx->branch, TEST7_BRANCH_ID)==0 ||
+	pj_stricmp2(&tsx->branch, TEST8_BRANCH_ID)==0) 
     {
 	/*
@@ -570,5 +570,5 @@
 	int code;
 
-	if (pj_strcmp2(&tsx->branch, TEST7_BRANCH_ID) == 0)
+	if (pj_stricmp2(&tsx->branch, TEST7_BRANCH_ID) == 0)
 	    code = TEST7_STATUS_CODE;
 	else
@@ -638,5 +638,5 @@
 
     } else
-    if (pj_strcmp2(&tsx->branch, TEST9_BRANCH_ID)==0)  {
+    if (pj_stricmp2(&tsx->branch, TEST9_BRANCH_ID)==0)  {
 	/*
 	 * TEST9_BRANCH_ID tests that retransmission of INVITE final response
@@ -702,7 +702,7 @@
 
     } else
-    if (pj_strcmp2(&tsx->branch, TEST10_BRANCH_ID)==0 ||
-	pj_strcmp2(&tsx->branch, TEST11_BRANCH_ID)==0 ||
-	pj_strcmp2(&tsx->branch, TEST12_BRANCH_ID)==0)  
+    if (pj_stricmp2(&tsx->branch, TEST10_BRANCH_ID)==0 ||
+	pj_stricmp2(&tsx->branch, TEST11_BRANCH_ID)==0 ||
+	pj_stricmp2(&tsx->branch, TEST12_BRANCH_ID)==0)  
     {
 	if (tsx->state == PJSIP_TSX_STATE_TERMINATED) {
@@ -740,6 +740,6 @@
     pj_status_t status;
 
-    if (pj_strcmp2(&branch_param, TEST1_BRANCH_ID) == 0 ||
-	pj_strcmp2(&branch_param, TEST2_BRANCH_ID) == 0) 
+    if (pj_stricmp2(&branch_param, TEST1_BRANCH_ID) == 0 ||
+	pj_stricmp2(&branch_param, TEST2_BRANCH_ID) == 0) 
     {
 	/*
@@ -750,5 +750,5 @@
 	 * TEST2_BRANCH_ID performs similar test for non-2xx final response.
 	 */
-	int status_code = (pj_strcmp2(&branch_param, TEST1_BRANCH_ID) == 0) ?
+	int status_code = (pj_stricmp2(&branch_param, TEST1_BRANCH_ID) == 0) ?
 			  TEST1_STATUS_CODE : TEST2_STATUS_CODE;
 
@@ -790,5 +790,5 @@
 	return PJ_TRUE;
 
-    } else if (pj_strcmp2(&branch_param, TEST3_BRANCH_ID) == 0) {
+    } else if (pj_stricmp2(&branch_param, TEST3_BRANCH_ID) == 0) {
 
 	/* TEST3_BRANCH_ID tests provisional response. */
@@ -839,7 +839,7 @@
 	return PJ_TRUE;
 
-    } else if (pj_strcmp2(&branch_param, TEST4_BRANCH_ID) == 0 ||
-	       pj_strcmp2(&branch_param, TEST5_BRANCH_ID) == 0 ||
-	       pj_strcmp2(&branch_param, TEST6_BRANCH_ID) == 0) 
+    } else if (pj_stricmp2(&branch_param, TEST4_BRANCH_ID) == 0 ||
+	       pj_stricmp2(&branch_param, TEST5_BRANCH_ID) == 0 ||
+	       pj_stricmp2(&branch_param, TEST6_BRANCH_ID) == 0) 
     {
 
@@ -864,10 +864,10 @@
 	    save_key(tsx);
 
-	    if (pj_strcmp2(&branch_param, TEST4_BRANCH_ID) == 0) {
-
-	    } else if (pj_strcmp2(&branch_param, TEST5_BRANCH_ID) == 0) {
+	    if (pj_stricmp2(&branch_param, TEST4_BRANCH_ID) == 0) {
+
+	    } else if (pj_stricmp2(&branch_param, TEST5_BRANCH_ID) == 0) {
 		send_response(rdata, tsx, TEST5_PROVISIONAL_CODE);
 
-	    } else if (pj_strcmp2(&branch_param, TEST6_BRANCH_ID) == 0) {
+	    } else if (pj_stricmp2(&branch_param, TEST6_BRANCH_ID) == 0) {
 		PJ_LOG(4,(THIS_FILE, "    sending provisional response"));
 		send_response(rdata, tsx, TEST6_PROVISIONAL_CODE);
@@ -883,9 +883,9 @@
 	    ++recv_count;
 
-	    if (pj_strcmp2(&branch_param, TEST4_BRANCH_ID) == 0) {
+	    if (pj_stricmp2(&branch_param, TEST4_BRANCH_ID) == 0) {
 		PJ_LOG(3,(THIS_FILE, "    error: not expecting response!"));
 		test_complete = -132;
 
-	    } else if (pj_strcmp2(&branch_param, TEST5_BRANCH_ID) == 0) {
+	    } else if (pj_stricmp2(&branch_param, TEST5_BRANCH_ID) == 0) {
 
 		if (rdata->msg_info.msg->line.status.code!=TEST5_PROVISIONAL_CODE) {
@@ -899,5 +899,5 @@
 		}
 
-	    } else if (pj_strcmp2(&branch_param, TEST6_BRANCH_ID) == 0) {
+	    } else if (pj_stricmp2(&branch_param, TEST6_BRANCH_ID) == 0) {
 
 		int code = rdata->msg_info.msg->line.status.code;
@@ -928,6 +928,6 @@
 
 
-    } else if (pj_strcmp2(&branch_param, TEST7_BRANCH_ID) == 0 ||
-	       pj_strcmp2(&branch_param, TEST8_BRANCH_ID) == 0) 
+    } else if (pj_stricmp2(&branch_param, TEST7_BRANCH_ID) == 0 ||
+	       pj_stricmp2(&branch_param, TEST8_BRANCH_ID) == 0) 
     {
 
@@ -951,5 +951,5 @@
 	    save_key(tsx);
 
-	    if (pj_strcmp2(&branch_param, TEST7_BRANCH_ID) == 0) {
+	    if (pj_stricmp2(&branch_param, TEST7_BRANCH_ID) == 0) {
 
 		send_response(rdata, tsx, TEST7_STATUS_CODE);
@@ -966,5 +966,5 @@
 	    ++recv_count;
 
-	    if (pj_strcmp2(&branch_param, TEST7_BRANCH_ID) == 0)
+	    if (pj_stricmp2(&branch_param, TEST7_BRANCH_ID) == 0)
 		code = TEST7_STATUS_CODE;
 	    else
@@ -1014,5 +1014,5 @@
 	return PJ_TRUE;
 
-    } else if (pj_strcmp2(&branch_param, TEST9_BRANCH_ID) == 0) {
+    } else if (pj_stricmp2(&branch_param, TEST9_BRANCH_ID) == 0) {
 
 	/*
@@ -1119,13 +1119,13 @@
 	return PJ_TRUE;
 
-    } else if (pj_strcmp2(&branch_param, TEST10_BRANCH_ID) == 0 ||
-	       pj_strcmp2(&branch_param, TEST11_BRANCH_ID) == 0 ||
-	       pj_strcmp2(&branch_param, TEST12_BRANCH_ID) == 0) 
+    } else if (pj_stricmp2(&branch_param, TEST10_BRANCH_ID) == 0 ||
+	       pj_stricmp2(&branch_param, TEST11_BRANCH_ID) == 0 ||
+	       pj_stricmp2(&branch_param, TEST12_BRANCH_ID) == 0) 
     {
 	int test_num, code1, code2;
 
-	if (pj_strcmp2(&branch_param, TEST10_BRANCH_ID) == 0)
+	if (pj_stricmp2(&branch_param, TEST10_BRANCH_ID) == 0)
 	    test_num=10, code1 = 100, code2 = 0;
-	else if (pj_strcmp2(&branch_param, TEST11_BRANCH_ID) == 0)
+	else if (pj_stricmp2(&branch_param, TEST11_BRANCH_ID) == 0)
 	    test_num=11, code1 = 100, code2 = 200;
 	else