Index: /pjproject/trunk/pjlib/src/pj/lock.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/lock.c	(revision 4410)
+++ /pjproject/trunk/pjlib/src/pj/lock.c	(revision 4411)
@@ -352,5 +352,5 @@
     while (lck != &glock->lock_list) {
 	if (lck->lock != glock->own_lock) {
-	    unsigned i;
+	    int i;
 	    for (i=0; i<glock->owner_cnt; ++i)
 		pj_lock_release(lck->lock);
@@ -448,25 +448,25 @@
 }
 
-PJ_DEF(pj_status_t) pj_grp_lock_replace( pj_grp_lock_t *old,
-                                         pj_grp_lock_t *new)
+PJ_DEF(pj_status_t) pj_grp_lock_replace( pj_grp_lock_t *old_lock,
+                                         pj_grp_lock_t *new_lock)
 {
     grp_destroy_callback *ocb;
 
     /* Move handlers from old to new */
-    ocb = old->destroy_list.next;
-    while (ocb != &old->destroy_list) {
+    ocb = old_lock->destroy_list.next;
+    while (ocb != &old_lock->destroy_list) {
 	grp_destroy_callback *ncb;
 
-	ncb = PJ_POOL_ALLOC_T(new->pool, grp_destroy_callback);
+	ncb = PJ_POOL_ALLOC_T(new_lock->pool, grp_destroy_callback);
 	ncb->comp = ocb->comp;
 	ncb->handler = ocb->handler;
-	pj_list_push_back(&new->destroy_list, ncb);
+	pj_list_push_back(&new_lock->destroy_list, ncb);
 
 	ocb = ocb->next;
     }
 
-    pj_list_init(&old->destroy_list);
-
-    grp_lock_destroy(old);
+    pj_list_init(&old_lock->destroy_list);
+
+    grp_lock_destroy(old_lock);
     return PJ_SUCCESS;
 }
@@ -615,5 +615,5 @@
 {
     grp_lock_item *lck, *new_lck;
-    unsigned i;
+    int i;
 
     grp_lock_acquire(glock);
@@ -654,5 +654,5 @@
 
     if (lck != &glock->lock_list) {
-	unsigned i;
+	int i;
 
 	pj_list_erase(lck);
Index: /pjproject/trunk/pjlib/src/pj/os_info.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/os_info.c	(revision 4410)
+++ /pjproject/trunk/pjlib/src/pj/os_info.c	(revision 4411)
@@ -243,4 +243,7 @@
 	    si.os_name = pj_str("Unknown");
 	}
+	
+	/* Avoid compile warning on Symbian. */
+	goto get_sdk_info;
     }
 #endif
Index: /pjproject/trunk/pjmedia/src/pjmedia/types.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/types.c	(revision 4410)
+++ /pjproject/trunk/pjmedia/src/pjmedia/types.c	(revision 4411)
@@ -38,8 +38,8 @@
     };
 
-    pj_assert(t < PJ_ARRAY_SIZE(type_names));
+    pj_assert(t < (int)PJ_ARRAY_SIZE(type_names));
     pj_assert(PJMEDIA_TYPE_UNKNOWN == 4);
 
-    if (t < PJ_ARRAY_SIZE(type_names))
+    if (t < (int)PJ_ARRAY_SIZE(type_names))
 	return type_names[t];
     else
Index: /pjproject/trunk/pjnath/src/pjnath/ice_strans.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/ice_strans.c	(revision 4410)
+++ /pjproject/trunk/pjnath/src/pjnath/ice_strans.c	(revision 4411)
@@ -1321,5 +1321,4 @@
     pj_ice_strans_comp *comp;
     pj_status_t status;
-    char daddr[PJ_INET6_ADDRSTRLEN];
 
     PJ_ASSERT_RETURN(comp_id && comp_id <= ice_st->comp_cnt, PJ_EINVAL);
Index: /pjproject/trunk/pjsip-apps/src/symbian_ua_gui/src/symbian_ua.cpp
===================================================================
--- /pjproject/trunk/pjsip-apps/src/symbian_ua_gui/src/symbian_ua.cpp	(revision 4410)
+++ /pjproject/trunk/pjsip-apps/src/symbian_ua_gui/src/symbian_ua.cpp	(revision 4411)
@@ -35,5 +35,4 @@
 static pjsua_acc_id g_acc_id = PJSUA_INVALID_ID;
 static pjsua_call_id g_call_id = PJSUA_INVALID_ID;
-static pjsua_buddy_id g_buddy_id = PJSUA_INVALID_ID;
 
 static symbian_ua_info_cb_t g_cb =  {NULL, NULL, NULL, NULL, NULL};
Index: /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 4410)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 4411)
@@ -870,5 +870,5 @@
 
     /* Start with the specified priority */
-    while (mod != &endpt->module_list && mod->priority < p->start_prio) {
+    while (mod != &endpt->module_list && mod->priority < (int)p->start_prio) {
 	mod = mod->next;
     }
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c	(revision 4410)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c	(revision 4411)
@@ -617,7 +617,8 @@
     tls->base.key.type = listener->factory.type;
     pj_sockaddr_cp(&tls->base.key.rem_addr, remote);
-    tls->base.type_name = (char*)
-			  pjsip_transport_get_type_name(tls->base.key.type);
-    tls->base.flag = pjsip_transport_get_flag_from_type(tls->base.key.type);
+    tls->base.type_name = (char*)pjsip_transport_get_type_name(
+				   (pjsip_transport_type_e)tls->base.key.type);
+    tls->base.flag = pjsip_transport_get_flag_from_type(
+				   (pjsip_transport_type_e)tls->base.key.type);
 
     tls->base.info = (char*) pj_pool_alloc(pool, 64);
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 4410)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 4411)
@@ -2168,5 +2168,5 @@
             call->last_code = PJSIP_SC_REQUEST_TERMINATED;
         else
-            call->last_code = code;
+            call->last_code = (pjsip_status_code)code;
         if (reason) {
             pj_strncpy(&call->last_text, reason,